unit uChoose;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,
  //--
  Lessons;

type
  TfChoose = class(TForm)
    listLessons: TListBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    labelDatei: TLabel;
    btnEdit: TBitBtn;
    btnChange: TBitBtn;
    btnDelete: TBitBtn;
    btnNew: TBitBtn;
    btnCancel: TButton;
    btnLoad: TButton;
    btnSave: TButton;
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnNewClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnChangeClick(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    procedure listLessonsDblClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  fChoose: TfChoose;

implementation
uses uEditor, uEditName;
{$R *.DFM}


procedure TfChoose.btnCancelClick(Sender: TObject);
begin
 Close;
end;

procedure TfChoose.FormShow(Sender: TObject);
begin
 fEditor.Enabled := false;
 listLessons.Items := fEditor.lesson1.getLessonsList;
 labelDatei.Caption := 'Lektionen in der Datei '+
                    ExtractFileName(fEditor.getFileName) +
                       ':';
end;

procedure TfChoose.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 fEditor.Enabled := true;
end;

procedure TfChoose.btnNewClick(Sender: TObject);
begin
 fEditName.MakeNewName(true);
end;

procedure TfChoose.btnDeleteClick(Sender: TObject);
var index: Integer;
begin
index := listLessons.ItemIndex;
if index > -1 then
 begin
   fEditor.lesson1.ListDelete(index);
   listLessons.Items := fEditor.lesson1.getLessonsList;
   fEditor.setSaved(false);
 end;
end;

procedure TfChoose.btnChangeClick(Sender: TObject);
begin
if listLessons.ItemIndex > -1 then
  fEditName.MakeNewName(false);
end;

procedure TfChoose.btnEditClick(Sender: TObject);
var index: Integer;
begin
index := listLessons.ItemIndex;
if index > -1 then
 begin
  fEditor.setLessonSelected(true, index);
  Close;
 end;
end;

procedure TfChoose.SpeedButton1Click(Sender: TObject);
var index: Integer;
begin
 index := listLessons.ItemIndex;
 if index > 0 then
   begin
     fEditor.lesson1.ListExchange(index, index-1);
     listLessons.Items := fEditor.lesson1.getLessonsList;
     listLessons.ItemIndex := index-1;
     fEditor.setSaved(false);
   end;
end;

procedure TfChoose.SpeedButton2Click(Sender: TObject);
var index: Integer;
begin
 index := listLessons.ItemIndex;
 if index < fEditor.lesson1.getList.Count - 1 then
   begin
     fEditor.lesson1.ListExchange(index, index+1);
     listLessons.Items := fEditor.lesson1.getLessonsList;
     listLessons.ItemIndex := index+1;
     fEditor.setSaved(false);
   end;
end;

procedure TfChoose.btnLoadClick(Sender: TObject);
var p_vocabulary: PVocabulary;
begin
 if fEditor.OpenDialog1.Execute then
   begin
     New(p_vocabulary);
     p_vocabulary^ := TVocabulary.Create;
     p_vocabulary^.LoadFromFile(fEditor.OpenDialog1.FileName);
     fEditor.lesson1.ListAdd(p_vocabulary);

     listLessons.Items := fEditor.lesson1.getLessonsList;
     fEditor.setSaved(false);
   end;
end;

procedure TfChoose.listLessonsDblClick(Sender: TObject);
var index: Integer;
begin
 index := listLessons.ItemIndex;
 if index > -1 then btnEditClick(Sender);
end;

procedure TfChoose.FormDeactivate(Sender: TObject);
begin
if Enabled and Visible then SetFocus;
end;

procedure TfChoose.btnSaveClick(Sender: TObject);
var index : Integer;
    p_vocabulary: PVocabulary;
begin
 index := listLessons.ItemIndex;
 if index > -1 then
  if fEditor.SaveDialog1.Execute then
   begin
     p_vocabulary := fEditor.lesson1.getList[index];
     p_vocabulary^.SaveToFile(fEditor.SaveDialog1.FileName);
   end;
end;

end.
