unit uEditName;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShellApi;

type
  TfEditName = class(TForm)
    edtNewName: TEdit;
    Label1: TLabel;
    btnClose: TButton;
    procedure btnCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    MakeNewLesson: Boolean;
    fIndex: Integer;
    procedure MakeNewName(makelesson: Boolean);
    { Public-Deklarationen }
  end;

var
  fEditName: TfEditName;

implementation
uses uEditor, uChoose, Lessons;
{$R *.DFM}

procedure TfEditName.btnCloseClick(Sender: TObject);
begin
 Close;
end;

procedure TfEditName.FormClose(Sender: TObject; var Action: TCloseAction);
var p_vocabulary: PVocabulary;
begin
if edtNewName.Text = '' then
  begin
   fChoose.Enabled := true;
   Exit;
  end;

 if MakeNewLesson then
  begin
     New(p_vocabulary);
     p_vocabulary^ := TVocabulary.Create;

     p_vocabulary^.setName(edtNewName.Text);
     fEditor.lesson1.ListAdd(p_vocabulary);
     fChoose.listLessons.Items := fEditor.lesson1.getLessonsList;
  end
 else
  begin
     p_vocabulary := fEditor.lesson1.getList[fIndex];
     p_vocabulary^.setName(edtNewName.Text);
     fChoose.listLessons.Items := fEditor.lesson1.getLessonsList;
     fChoose.listLessons.ItemIndex := fIndex;
  end;

 fEditor.setSaved(false);

 fChoose.Enabled := true;
end;

procedure TfEditName.FormShow(Sender: TObject);
begin
  fChoose.Enabled := false;
  MakeNewLesson := false;
  SetWindowPos(fChoose.Handle, HWND_TOP,0,0,0,0,SWP_NOMOVE+SWP_NOSIZE+SWP_SHOWWINDOW);
  SetWindowPos(Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE+SWP_NOSIZE+SWP_SHOWWINDOW);
end;

procedure TfEditName.MakeNewName(makelesson: Boolean);
var p_vocabulary: PVocabulary;
begin
  Show;
  MakeNewLesson := makelesson;
  if MakeNewLesson then
   begin
     edtNewName.Text := '';
   end
  else
   begin
    fIndex := fChoose.listLessons.ItemIndex;
    p_vocabulary := fEditor.lesson1.getList[fIndex];
    edtNewName.Text := p_vocabulary^.getName;
   end;
end;

end.
