(********************************************************
 * Form fEditor
 * Unit uEditor
 *
 * Hauptform fr das Modul EditLessons
 *
 * Datum: 22.04.2000
 * Autor: Andreas Dangel
 * Version: 0.9b
 *
 * (c)2000 Andreas Dangel
 *******************************************************)
unit uEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Buttons,
  //--
  uChoose, Lessons, ShellApi, inifiles, ExtCtrls;

type
  TfEditor = class(TForm)
   (* Men *)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    NeueLektionsdateierstelle1: TMenuItem;
    VorhandeneLektionsdateiffnen1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Lektionsdateispeichern1: TMenuItem;
    Lektionsdateispeichernunter1: TMenuItem;
    Beenden1: TMenuItem;
    Lektionen1: TMenuItem;
    Auswhlen1: TMenuItem;
    Einstellungen1: TMenuItem;
    mnuLeerzeichen: TMenuItem;
    Neu1: TMenuItem;
   (* ffnen- und Speichern-Dialoge *)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
   (* in diesem Panel sind die Buttons *)
    panelButtons: TPanel;
    btnAdd: TBitBtn;
    btnChange: TBitBtn;
    btnDelete: TBitBtn;
    btnClear: TBitBtn;
   (* in diesem Panel ist edtLektionsname *)
    panelLektionsname: TPanel;
    edtLektionsname: TEdit;
    labelLektionsname: TLabel;
   (* Panel, das die Vokabelliste beinhaltet *)
    panelVokabelliste: TPanel;
    labelVokabelliste: TLabel;
    listVokabel: TListBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    labelAnzahl: TLabel;
   (* Panel, in dem die Eingabefelder sind *)
    panelEingabe: TPanel;
    labelVokabel: TLabel;
    edtVokabel: TEdit;
    labelBedeutungen: TLabel;
    memoBedeutungen: TMemo;
    labelBemerkung: TLabel;
    edtBemerkung: TEdit;

   (* Ereignis-Methoden *)
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    //Men
    procedure NeueLektionsdateierstelle1Click(Sender: TObject);
    procedure VorhandeneLektionsdateiffnen1Click(Sender: TObject);
    procedure Lektionsdateispeichern1Click(Sender: TObject);
    procedure Lektionsdateispeichernunter1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure Neu1Click(Sender: TObject);
    procedure Auswhlen1Click(Sender: TObject);
    procedure mnuLeerzeichenClick(Sender: TObject);
    //Men ende

    procedure listVokabelClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);

    procedure btnAddClick(Sender: TObject);
    procedure btnChangeClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);

    procedure edtLektionsnameChange(Sender: TObject);
    procedure edtVokabelChange(Sender: TObject);
    procedure memoBedeutungenChange(Sender: TObject);
    procedure edtBemerkungChange(Sender: TObject);
  private
    { Private-Deklarationen }
    (* speichert den ausgewhlten Dateinamen *)
    fFileName: String;
    (* Status: wurde schon gespeichert? *)
    fSaved   : Boolean;
    (* Status: wurde eine Lektion ausgewhlt
     * -> fChoose
     *)
    fLessonSelected: Boolean;

    (* Eingabefelder Leeren *)
    procedure FelderLeeren;
    procedure AllesLeeren;

    (* entfernt bestimmte Zeichen *)
    procedure removeDelimiter(component: TComponent);
    procedure removeBreakes(component: TComponent);
  public
    (* wenn diese Form von vok2000 aus aufgerufen wird *)
    parentForm: ^TForm;
    (*********************************)
    fInitialized: Boolean;
    lesson1: TLessons;
    vocabularyIndex: Integer;
    procedure setLessonSelected(flag: Boolean; index: Integer);
    function getLessonSelected: Boolean;
    procedure setSaved(flag: Boolean);
    function getFileName: String;
    procedure setFileName(filename: String);
    procedure setInitialized(flag: Boolean);
    { Public-Deklarationen }
  end;

var
  fEditor: TfEditor;

implementation
var p_vocabulary: PVocabulary;
    p_vocabel: PVocabel;

{$R *.DFM}


procedure TfEditor.FormCreate(Sender: TObject);
var ini: TInifile;
    f: String;
begin
 (* erste einstellung: nicht von vok2000 aus aufgerufen *)
 parentForm := nil;

 (* lektion gespeichert *)
 setSaved(true);

 setInitialized(false);
 setLessonSelected(false,-1);

 (* einstellungen laden *)
 f := ExtractFilePath(Application.ExeName)+'vokabel.ini';
 ini := TIniFile.Create(f);
 (* Leerzeichen am Ende entfernen *)
 mnuLeerzeichen.Checked := ini.ReadBool('edit','leerzeichen',true);
 ini.Free;

end;

procedure TfEditor.FormShow(Sender: TObject);
begin
 (* wenn ein Parameter angegeben wurde... *)
 if ParamCount > 0 then
   (* wenn die datei existiert *)
   if FileExists(ParamStr(1)) then
    begin
     fFileName := ParamStr(1);
     if not fInitialized then
       begin
         lesson1 := TLessons.Create;
         setInitialized(true);
       end;
      (* Lektion laden *)
     lesson1.LoadFromFile(fFileName);
     Caption := fFileName;
     fChoose.Show;
     SetWindowPos(fChoose.Handle, HWND_TOPMOST,
                  0,0,0,0,SWP_NOMOVE+SWP_NOSIZE+SWP_SHOWWINDOW);
    end;
end;

procedure TfEditor.FormClose(Sender: TObject; var Action: TCloseAction);
var ret: Integer;
begin
 (* warnungsfrage, wenn nicht gespeichert *)
 if not fSaved then
   begin
     ret := MessageDlg(
               'Lektionsdatei nicht gespeichert!'+#10+
               'Jetzt speichern?',
                mtConfirmation, [mbYes,mbNo], 0);
     if ret = mrYes then Lektionsdateispeichern1Click(Sender);
   end;

 (* wenn EditLesson von vok2000 aus aufgerufen wurde,
  * dann ist parentForm <> nil und ein Zeiger auf
  * die Form von vok2000
  *)
 if parentForm <> nil then parentForm^.Show;
end;

procedure TfEditor.NeueLektionsdateierstelle1Click(Sender: TObject);
begin
 (* wenn nicht gespeichert -> speichern *)
 if not fSaved then Lektionsdateispeichern1Click(Sender);

 (* neue Lektion erstellen *)
 lesson1 := TLessons.Create;
 fFileName := '';
 setInitialized(true);
 AllesLeeren;
 Caption := 'Editor';
 setSaved(true);
end;

procedure TfEditor.VorhandeneLektionsdateiffnen1Click(Sender: TObject);
begin
 (* wenn nicht gespeichert -> speichern *)
 if not fSaved then Lektionsdateispeichern1Click(Sender);

 if OpenDialog1.Execute then
   begin
     fFileName := OpenDialog1.FileName;
     if not fInitialized then
       begin
         lesson1 := TLessons.Create;
         setInitialized(true);
       end;
     lesson1.LoadFromFile(fFileName);
     Caption := fFileName;
     Auswhlen1Click(Sender);
   end;
end;

procedure TfEditor.Lektionsdateispeichernunter1Click(Sender: TObject);
begin
 if SaveDialog1.Execute then
   begin
     fFileName := SaveDialog1.FileName;
     lesson1.SaveToFile(fFileName);
     setSaved(true);
     Caption := fFileName;
   end;

end;

procedure TfEditor.Lektionsdateispeichern1Click(Sender: TObject);
begin
 if fFileName <> '' then
   begin
     lesson1.SaveToFile(fFileName);
     setSaved(true);
   end
 else Lektionsdateispeichernunter1Click(Sender);
end;

procedure TfEditor.Beenden1Click(Sender: TObject);
begin
 (* form schlieen *)
 Close;
end;

procedure TfEditor.btnClearClick(Sender: TObject);
begin
 FelderLeeren;
end;

procedure TfEditor.FelderLeeren;
begin
 edtVokabel.Text := '';
 memoBedeutungen.Clear;
 edtBemerkung.Text := '';
 edtVokabel.SetFocus;
end;

procedure TfEditor.AllesLeeren;
begin
 FelderLeeren;
 edtLektionsname.Text := '';
 listVokabel.Clear;
end;



procedure TfEditor.setInitialized(flag: Boolean);
begin
  fInitialized := flag;
  Lektionsdateispeichern1.Enabled := fInitialized;
  Lektionsdateispeichernunter1.Enabled := fInitialized;
  Auswhlen1.Enabled := fInitialized;
  labelAnzahl.Caption := 'Anzahl: 0';
  Neu1.Enabled := fInitialized;
end;


procedure TfEditor.setLessonSelected(flag: Boolean; index: Integer);
var p_vocabulary: PVocabulary;
begin
 fLessonSelected := flag;
 vocabularyIndex := index;
 if fLessonSelected then
  begin
   p_vocabulary := lesson1.getList[vocabularyIndex];
   listVokabel.Items := p_vocabulary^.getVokabelList;
   labelAnzahl.Caption := 'Anzahl: '+IntToStr(listVokabel.Items.Count);
   edtLektionsname.Text := p_vocabulary^.getName;
  end;
end;

function TfEditor.getLessonSelected: Boolean;
begin
 Result := fLessonSelected;
end;

procedure TfEditor.Auswhlen1Click(Sender: TObject);
begin
 fChoose.Show;
end;

procedure TfEditor.setSaved(flag: Boolean);
var testCaption: String;
begin
 fSaved := flag;
 (* in Caption ein '*' hinzufgen, wenn nicht gespeichert
  * ist, sonst entfernen
  * aber: immer nur, wenn vorhanden bzw. nicht vorhanden...
  *)
 testCaption := copy(Caption, Length(Caption)-1, 2);
 if fSaved then (*entfernen*)
     (*wenn vorhanden*)
     if testCaption = ' *' then
       Caption := copy(Caption,0,Length(Caption)-2);
 if not fSaved then (*hinzufgen*)
     (*wenn nicht vorhanden*)
     if not (testCaption = ' *') then
        Caption := Caption + ' *';

end;


function TfEditor.getFileName: String;
begin
 Result := fFileName;
end;

procedure TfEditor.SpeedButton1Click(Sender: TObject);
var index: Integer;
begin
 if not getLessonSelected then Exit;

 index := listVokabel.ItemIndex;
 if index > 0 then
  begin
    p_vocabulary := lesson1.getList[vocabularyIndex];
    p_vocabulary^.ListExchange(index, index-1);
    listVokabel.Items := p_vocabulary^.getVokabelList;
    listVokabel.ItemIndex := index - 1;
    setSaved(false);
  end;
end;

procedure TfEditor.SpeedButton2Click(Sender: TObject);
var index: Integer;
begin
 if not getLessonSelected then Exit;

 index := listVokabel.ItemIndex;
 if index < listVokabel.Items.Count - 1 then
   begin
     p_vocabulary := lesson1.getList[vocabularyIndex];
     p_vocabulary^.ListExchange(index, index + 1);
     listVokabel.Items := p_vocabulary^.getVokabelList;
     listVokabel.ItemIndex := index + 1;
     setSaved(false);
   end;
end;

procedure TfEditor.btnDeleteClick(Sender: TObject);
var index: Integer;
begin
 if not getLessonSelected then
   begin
     ShowMessage('Du musst erst eine Lektion auswhlen!');
     Exit;
   end;

 index := listVokabel.ItemIndex;
 if index > -1 then
   begin
     p_vocabulary := lesson1.getList[vocabularyIndex];
     p_vocabulary^.ListDelete(index);
     listVokabel.Items := p_vocabulary^.getVokabelList;
     labelAnzahl.Caption := 'Anzahl: '+
                         IntToStr(listVokabel.Items.Count);
     setSaved(false);
     edtVokabel.SetFocus;
   end;
end;

procedure TfEditor.btnChangeClick(Sender: TObject);
var index : Integer;
begin
 if not getLessonSelected then
   begin
     ShowMessage('Du musst erst eine Lektion auswhlen!');
     Exit;
   end;

 //leerzeichen
 if mnuLeerzeichen.Checked then
  begin
   removeBreakes(edtVokabel);
   removeBreakes(memoBedeutungen);
   removeBreakes(edtBemerkung);
  end;

 index := listVokabel.ItemIndex;
 if index > -1 then
   begin
     p_vocabulary := lesson1.getList[vocabularyIndex];
     New(p_vocabel);
     p_vocabel^ := TVocabel.Create;
     p_vocabel^.setVokabel(edtVokabel.Text);
     p_vocabel^.setBedeutungen(memoBedeutungen.Lines);
     p_vocabel^.setBemerkung(edtBemerkung.Text);

     p_vocabulary^.ListInsert(index, p_vocabel);
     p_vocabulary^.ListDelete(index + 1);

     listVokabel.Items := p_vocabulary^.getVokabelList;
     setSaved(false);
     FelderLeeren;
   end;
end;

procedure TfEditor.btnAddClick(Sender: TObject);
begin
 if not getLessonSelected then
   begin
     ShowMessage('Du musst erst eine Lektion auswhlen!');
     Exit;
   end;

 //leerzeichen
 if mnuLeerzeichen.Checked then
  begin
   removeBreakes(edtVokabel);
   removeBreakes(memoBedeutungen);
   removeBreakes(edtBemerkung);
  end;

 p_vocabulary := lesson1.getList[vocabularyIndex];
 New(p_vocabel);
 p_vocabel^ := TVocabel.Create;
 p_vocabel^.setVokabel(edtVokabel.Text);
 p_vocabel^.setBedeutungen(memoBedeutungen.Lines);
 p_vocabel^.setBemerkung(edtBemerkung.Text);

 p_vocabulary^.ListAdd(p_vocabel);

 listVokabel.Items := p_vocabulary^.getVokabelList;
 labelAnzahl.Caption := 'Anzahl: '+
           IntToStr(listVokabel.Items.Count);
 setSaved(false);
 FelderLeeren;
end;

procedure TfEditor.listVokabelClick(Sender: TObject);
var index: Integer;
begin
if not getLessonSelected then Exit;

 index := listVokabel.ItemIndex;
 if index > -1 then
   begin
     p_vocabulary := lesson1.getList[vocabularyIndex];
     p_vocabel := p_vocabulary^.getList[index];

     edtVokabel.Text := p_vocabel^.getVokabel;
     memoBedeutungen.Lines := p_vocabel^.getBedeutungen;
     edtBemerkung.Text := p_vocabel^.getBemerkung;
   end;
end;

procedure TfEditor.edtLektionsnameChange(Sender: TObject);
begin
if not getLessonSelected then Exit;

removeDelimiter(edtLektionsname);

p_vocabulary := lesson1.getList[vocabularyIndex];
if p_vocabulary^.getName <> edtLektionsname.Text then
 begin
  p_vocabulary^.setName(edtLektionsname.Text);
  setSaved(false);
 end;
end;

procedure TfEditor.removeDelimiter(component: TComponent);
var text: String;
    p: Integer;
    x: Integer;
begin
 if component is TEdit then
  begin
    text := (component as TEdit).Text;
    p := pos(DELIMITER, text);
    if p > 0 then
      begin
       x := (component as TEdit).SelStart;
       text := copy(text,0,p-1)+copy(text,p+1,length(text));
       (component as TEdit).Text := text;
       (component as TEdit).SelStart := x-1;
      end;
  end
  else
  if component is TMemo then
   begin
     text := (component as TMemo).Text;
     p := pos(DELIMITER, text);
     if p > 0 then
       begin
        x := (component as TMemo).SelStart;
        text := copy(text,0,p-1)+copy(text,p+1,length(text));
        (component as TMemo).Text := text;
        (component as TMemo).SelStart := x-1;
       end;
   end;
end;

procedure TfEditor.edtVokabelChange(Sender: TObject);
begin
if not getLessonSelected then Exit;

removeDelimiter(edtVokabel);
end;

procedure TfEditor.memoBedeutungenChange(Sender: TObject);
begin
if not getLessonSelected then Exit;

removeDelimiter(memoBedeutungen);
end;

procedure TfEditor.edtBemerkungChange(Sender: TObject);
begin
if not getLessonSelected then Exit;

removeDelimiter(edtBemerkung);
end;

procedure TfEditor.setFileName(filename: String);
begin
 fFileName := filename;
end;


procedure TfEditor.mnuLeerzeichenClick(Sender: TObject);
var ini: TInifile;
    f: String;
begin
 if mnuLeerzeichen.Checked then mnuLeerzeichen.Checked := false
                           else mnuLeerzeichen.Checked := true;

 //einstellungen speichern
 f := ExtractFilePath(Application.ExeName)+'vokabel.ini';
 ini := TIniFile.Create(f);
 ini.WriteBool('edit','leerzeichen',mnuLeerzeichen.Checked);
 ini.Free;
end;

procedure TfEditor.removeBreakes(component: TComponent);
var s: String;
    i,y: Integer;
begin
 if component is TEdit then
  begin
    s := (component as TEdit).Text;
    for i := Length(s) downto 0 do
      begin
        if copy(s,Length(s),1) = ' ' then
           s := copy(s,0,Length(s)-1)
        else Break;
      end;
    (component as TEdit).Text := s;
  end
 else
 if component is TMemo then
  begin
    for y := 0 to (component as TMemo).Lines.Count-1 do
     begin
      s := (component as TMemo).Lines[y];
      for i := Length(s) downto 0 do
        begin
          if copy(s,Length(s),1)=' ' then
             s := copy(s,0,Length(s)-1)
          else Break;
        end;
      (component as TMemo).Lines[y] := s;
     end;
  end;
end;
procedure TfEditor.Neu1Click(Sender: TObject);
begin
 fChoose.Show;
 fChoose.btnNewClick(Sender);
end;

end.
