unit RegisterFileTypes;

interface
uses Classes, registry, SysUtils, Windows;

procedure RegisterFileType(exename: String);
procedure RemoveRegistration;

implementation
procedure RegisterFileType(exename: String);
var reg: TRegistry;
begin
 reg := TRegistry.Create;
 reg.RootKey := HKEY_CLASSES_ROOT;

 reg.OpenKey('\.lek', true);
 reg.WriteString('','lek_file');
 reg.CloseKey;

 reg.OpenKey('\lek_file', true);
 reg.WriteString('','Lektionsdatei');
 reg.CloseKey;

 reg.OpenKey('\lek_file\DefaultIcon', true);
 reg.WriteString('',exename);
 reg.CloseKey;

 reg.OpenKey('\lek_file\shell', true);
 reg.WriteString('','open');
 reg.CloseKey;

 reg.OpenKey('\lek_file\shell\open\command', true);
 reg.WriteString('',exename+' "%1"');
 reg.CloseKey;

 reg.Free;
end;

procedure RemoveRegistration;
var reg: TRegistry;
begin
 reg := TRegistry.Create;
 reg.RootKey := HKEY_CLASSES_ROOT;
 reg.DeleteKey('\.lek');
 reg.DeleteKey('\lek_file');
 reg.Free;
end;

end.
 