unit uSettings;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Inifiles;

type
  TfSettings = class(TForm)
    radioRichtung: TRadioGroup;
    radioReihenfolge: TRadioGroup;
    GroupBox1: TGroupBox;
    chkFehler: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    GroupBox2: TGroupBox;
    chkBemerkung: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  fSettings: TfSettings;

implementation
uses uTrainer;
{$R *.DFM}

procedure TfSettings.FormShow(Sender: TObject);
begin
 fTrainer.Enabled := false;
end;

procedure TfSettings.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 fTrainer.Enabled := true;
end;

procedure TfSettings.FormCreate(Sender: TObject);
var inifile: TIniFile;
    filename: String;
begin
 //einstellungen aus inidatei laden...
 filename := ExtractFilePath(Application.ExeName)+'vokabel.ini';
 inifile := TIniFile.Create(filename);
 radioRichtung.ItemIndex := inifile.ReadInteger('trainer','richtung',2);
 radioReihenfolge.ItemIndex := inifile.ReadInteger('trainer','reihenfolge',0);
 chkFehler.Checked := inifile.ReadBool('trainer','fehler',true);
 chkBemerkung.Checked := inifile.ReadBool('trainer','bemerkung',true);
 inifile.Free;
end;

procedure TfSettings.Button1Click(Sender: TObject);
begin
 radioRichtung.ItemIndex := 2;
 radioReihenfolge.ItemIndex := 0;
 chkFehler.Checked := true;
 chkBemerkung.Checked := true;
end;

procedure TfSettings.Button3Click(Sender: TObject);
begin
 Close;
end;

procedure TfSettings.Button2Click(Sender: TObject);
var inifile: TIniFile;
    filename: String;
begin
//einstellungen speichern
filename := ExtractFilePath(Application.ExeName)+'vokabel.ini';
inifile := TIniFile.Create(filename);
inifile.WriteInteger('trainer','richtung',radioRichtung.ItemIndex);
inifile.WriteInteger('trainer','reihenfolge',radioReihenfolge.ItemIndex);
inifile.WriteBool('trainer','fehler',chkFehler.Checked);
inifile.WriteBool('trainer','bemerkung',chkBemerkung.Checked);
inifile.Free;

Close;
end;

end.
