unit uTrainer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, ExtCtrls, Buttons,
  //--
  Lessons, ShellApi;

type
  TfTrainer = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Lektionsdateiffnen1: TMenuItem;
    Lektionenauswhlen1: TMenuItem;
    N1: TMenuItem;
    Drucken1: TMenuItem;
    Einzeln1: TMenuItem;
    Liste1: TMenuItem;
    DruckerEinrichtung1: TMenuItem;
    N2: TMenuItem;
    Beenden1: TMenuItem;
    Einstellungen1: TMenuItem;
    Abfrage1: TMenuItem;
    Info1: TMenuItem;
    Start1: TMenuItem;
    Betrachten1: TMenuItem;
    N3: TMenuItem;
    Vokabeln1: TMenuItem;
    Erfolg1: TMenuItem;
    Benutzen1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    StatusBar1: TStatusBar;
    memoStatus: TMemo;
    Panel1: TPanel;
    btnGo: TBitBtn;
    panelBemerkung: TPanel;
    edtBemerkung: TEdit;
    Label2: TLabel;
    panelVokabelBedeutungen: TPanel;
    edtVokabel: TEdit;
    labelVokabel: TLabel;
    memoBedeutungen: TMemo;
    labelBedeutungen: TLabel;
    ampel: TShape;
    Label1: TLabel;
    procedure Beenden1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Lektionsdateiffnen1Click(Sender: TObject);
    procedure Lektionenauswhlen1Click(Sender: TObject);
    procedure btnGoClick(Sender: TObject);
    procedure Abfrage1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Benutzen1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Betrachten1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    parentForm: ^TForm;
    timer_seconds: Integer;
    timer_minutes: Integer;
    richtige: Integer;
    falsche: Integer;
    aktRichtung: Integer;
    listReihenfolge: TStringList;
    listZufall: TStringList;
    lesson1: TLessons;
    vocabulary1: TVocabulary;
    FileName: String;
    vocabularyInit: Boolean;
    procedure setVocabularyInit(flag: Boolean);
    procedure incRichtige;
    procedure incFalsche;
    procedure sayRest;
    procedure showResults;
    { Public-Deklarationen }
  end;

var
  fTrainer: TfTrainer;

implementation
uses uChoose2, uSettings, uLexikon;

{$R *.DFM}

procedure TfTrainer.Beenden1Click(Sender: TObject);
begin

 Close;
end;

procedure TfTrainer.FormCreate(Sender: TObject);
begin
 parentForm := nil;

 lesson1 := TLessons.Create;
 vocabulary1 := TVocabulary.Create;
 listReihenfolge := TStringList.Create;
 listZufall := TStringList.Create;
 Randomize;
 setVocabularyInit(false);
end;

procedure TfTrainer.FormDestroy(Sender: TObject);
begin
 lesson1.Free;
// vocabulary1.Free;
 listReihenfolge.Free;
 listZufall.Free;
end;

procedure TfTrainer.Lektionsdateiffnen1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
   begin
    FileName := OpenDialog1.FileName;
    lesson1.LoadFromFile(FileName);
    Lektionenauswhlen1Click(Sender);
    Lektionenauswhlen1.Enabled := true;
    Benutzen1.Enabled := true;
   end;
end;

procedure TfTrainer.Lektionenauswhlen1Click(Sender: TObject);
begin
//wenn gerade was am laufen ist...
if Timer1.Enabled then
  begin
   Timer1.Enabled := false;
   //Auswertung anzeigen (showMessage...)
   showResults;
   setVocabularyInit(true);
  end;

 fChoose2.Show;
end;

procedure TfTrainer.setVocabularyInit(flag: Boolean);
var i: Integer;
    r: Integer;
begin
  vocabularyInit := flag;
  btnGo.Caption := 'Start';
  memoStatus.Text := '   ';
  edtVokabel.Text := '';
  memoBedeutungen.Text := '';
  edtBemerkung.Text := '';
  richtige := 0;
  falsche := 0;
  btnGo.Enabled := vocabularyInit;
  Betrachten1.Enabled := vocabularyInit;
  Vokabeln1.Enabled := vocabularyInit;
  Info1.Enabled := vocabularyInit;
  Caption := 'Vokabeltrainer - '+vocabulary1.getName;
  if vocabularyInit then
    begin
      //zurcksetzen der Zeit
      timer_seconds := 0;
      timer_minutes := 0;
      //Statusbar lschen:
      for i := 0 to StatusBar1.Panels.Count-1 do
        StatusBar1.Panels[i].Text := '';
      //reihenfolge festlegen
      case fSettings.radioReihenfolge.ItemIndex of
        //zufllig
        0: begin
             listZufall.Clear;
             listReihenfolge.Clear;
             for i := 0 to vocabulary1.getList.Count-1 do
                listZufall.Add(IntToStr(i));
             for i := 0 to vocabulary1.getList.Count-1 do
                begin
                  r := Random(listZufall.Count);
                  listReihenfolge.Add(listZufall[r]);
                  listZufall.Delete(r);
                end;
           end;
        //wie eingegeben
        1: begin
            listReihenfolge.Clear;
            for i := 0 to vocabulary1.getList.Count-1 do
               listReihenfolge.Add(IntToStr(i));
           end;
      end;
    end;
end;


procedure TfTrainer.btnGoClick(Sender: TObject);
var aktIndex: Integer;
    p_vocabel: PVocabel;
    i: Integer;
    isRichtig: Boolean;
    s: String;
begin
//wenn keine weiteren Vokabeln folgen
if listReihenfolge.Count = 0 then
 begin
   Timer1.Enabled := false;
   //Auswertung anzeigen (showMessage...)
   showResults;
   setVocabularyInit(true);
   Exit;
 end;

 aktIndex := StrToInt(listReihenfolge[0]);
 p_vocabel := vocabulary1.getList[aktIndex];

 //sicherstellen, dass der Timer luft
 if not Timer1.Enabled then Timer1.Enabled := true;

 //fall 1: wrter anzeigen:
 //wenn in memoStatus schon was steht, d.h.
 //wenn schon bewertet wurde
 if memoStatus.Text <> '' then
   begin
     btnGo.Caption := 'F&ertig';
     memoStatus.Text := '';
     edtVokabel.Text := '';
     memoBedeutungen.Text := '';
     edtBemerkung.Text := '';
     ampel.Brush.Color := clYellow;
     //bemerkung gegebenenfalls anzeigen
     if fSettings.chkBemerkung.Checked then
        edtBemerkung.Text := p_vocabel^.getBemerkung;
     //wenn betrachten gewnscht...
     if Betrachten1.Checked then
       begin
         memoStatus.Text := 'Betrachten...';
         edtVokabel.Text := p_vocabel^.getVokabel;
         memoBedeutungen.Lines := p_vocabel^.getBedeutungen;
         edtBemerkung.Text := p_vocabel^.getBemerkung;
         listReihenfolge.Delete(0);
         sayRest;
         Timer1.Enabled := false;
         Exit;
       end;

     //richtung bestimmen
     aktRichtung := fSettings.radioRichtung.ItemIndex;
     if aktRichtung = 2 then aktRichtung := Random(2);
     case aktRichtung of
     // vok->bed
     0: begin
         edtVokabel.Text := p_vocabel^.getVokabel;
         edtVokabel.ReadOnly := true;
         memoBedeutungen.ReadOnly := false;
         memoBedeutungen.SetFocus;
        end;
     // bed->vok
     1: begin
         memoBedeutungen.Lines := p_vocabel^.getBedeutungen;
         memoBedeutungen.ReadOnly := true;
         edtVokabel.ReadOnly := false;
         edtVokabel.SetFocus;
        end;
     end;
   end
 //fall 2: anzeige berprfen....
 //wenn in memoStatus noch nichts steht...
 else
   begin
     btnGo.Caption := 'W&eiter';
     //richtung feststellen
     case aktRichtung of
     //vok->bed gefragt
     0: begin
         //zunchst leere zeilen am Ende entfernen...
         for i := memoBedeutungen.Lines.Count-1 downto 0 do
           begin
             if memoBedeutungen.Lines[i] = '' then
                     memoBedeutungen.Lines.Delete(i)
             else Break;
           end;

           //bedeutungen berprfen
             isRichtig := true;
             for i := 0 to memoBedeutungen.Lines.Count-1 do
               begin
                //zeilenweise berprfen...
                if p_vocabel^.getBedeutungen.IndexOf(memoBedeutungen.Lines[i]) = -1 then
                  //nicht enthalten
                  isRichtig := false;
               end;

               //jetzt noch die anzahl der bedeutungen berprfen:
               if memoBedeutungen.Lines.Count <> p_vocabel^.getBedeutungen.Count then
                  isRichtig := false;

               //wenn alle Zeilen in p_vocabel enthalten waren,
               //dann msste isRichtig noch true sein...
               if isRichtig then
                 begin
                   memoStatus.Lines.Add('Das war RICHTIG!');
                   ampel.Brush.Color := clGreen;
                   listReihenfolge.Delete(0);
                   incRichtige;
                   edtBemerkung.Text := p_vocabel^.getBemerkung;
                 end
                else
                 begin
                   memoStatus.Lines.Add('Das war FALSCH!');
                   memoStatus.Lines.Add('Richtig wre gewesen:');
                   s := '';
                   for i := 0 to p_vocabel^.getBedeutungen.Count-1 do
                      s := s + p_vocabel^.getBedeutungen[i] + ' | ';
                   //letztes | entfernen
                   s := copy(s,0,Length(s)-3);
                   memoStatus.Lines.Add(s);
                   ampel.Brush.Color := clRed;
                   incFalsche;
                   edtBemerkung.Text := p_vocabel^.getBemerkung;
                    //fehlerbehandlung:
                    if fSettings.chkFehler.Checked then
                      listReihenfolge.Exchange(0, Random(listReihenfolge.Count))
                    else listReihenfolge.Delete(0);
                 end;
        end;
     //bed->vok gefragt
     1: begin
          if edtVokabel.Text = p_vocabel^.getVokabel then
            begin
             //richtig:
             memoStatus.Lines.Add('Das war RICHTIG!');
             ampel.Brush.Color := clGreen;
             //vokabel aus der liste lschen
             listReihenfolge.Delete(0);
             incRichtige;
             edtBemerkung.Text := p_vocabel^.getBemerkung;
            end
          else
            begin
             //falsch:
             memoStatus.Lines.Add('Das war FALSCH!');
             memoStatus.Lines.Add('Richtig wre gewesen:');
             memoStatus.Lines.Add(p_vocabel^.getVokabel);
             ampel.Brush.Color := clRed;
             incFalsche;
             edtBemerkung.Text := p_vocabel^.getBemerkung;
             //fehlerbehandlung:
             if fSettings.chkFehler.Checked then
                 listReihenfolge.Exchange(0, Random(listReihenfolge.Count))
             else listReihenfolge.Delete(0);

            end;
        end;
     end;
   end;
 end;

procedure TfTrainer.Abfrage1Click(Sender: TObject);
begin
 fSettings.Show;
end;

procedure TfTrainer.Timer1Timer(Sender: TObject);
var timeString: String;
begin
 Timer1.Enabled := false;

 timer_seconds := timer_seconds + 1;
 if timer_seconds >= 60 then
   begin
    timer_minutes := timer_minutes + 1;
    timer_seconds := 0;
   end;

 //leading zero....
 if timer_minutes < 10 then
      timeString := '0'+IntToStr(timer_minutes)
 else timeString := IntToStr(timer_minutes);
 if timer_seconds < 10 then
      timeString := timeString + ':0' + IntToStr(timer_seconds)
 else timeString := timeString + ':' + IntToStr(timer_seconds);

 StatusBar1.Panels[0].Text := timeString;

 Timer1.Enabled := true;
end;

procedure TfTrainer.incRichtige;
var text: String;
begin
 richtige := richtige + 1;
 text := IntToStr(richtige)+' von '+IntToStr(richtige+falsche);
 text := text + ' richtig';
 text := text + ' (';
 text := text + IntToStr(Round(richtige*100/(richtige+falsche)));
 text := text + '%)';
 StatusBar1.Panels[1].Text := text;
 sayRest;
end;

procedure TfTrainer.incFalsche;
var text: String;
begin
 falsche := falsche + 1;
 text := IntToStr(richtige)+' von '+IntToStr(richtige+falsche);
 text := text + ' richtig';
 text := text + ' (';
 text := text + IntToStr(Round(richtige*100/(richtige+falsche)));
 text := text + '%)';
 StatusBar1.Panels[1].Text := text;
 sayRest;
end;

procedure TfTrainer.sayRest;
var rest: Integer;
    text: String;
begin
 rest := listReihenfolge.Count;
 text := 'noch '+IntToStr(rest)+' Vokabeln';
 text := text + ' (';
// if rest = 0 then rest := 1;
 text := text + IntToStr(Round(richtige*100/(rest+richtige)));
 text := text + '% erledigt)';
 StatusBar1.Panels[2].Text := text;
end;

procedure TfTrainer.Info1Click(Sender: TObject);
var text: String;
begin
 if Timer1.Enabled then text := 'Es werden noch '
                  else text := 'Es werden ';
 text := text + IntToStr(listReihenfolge.Count)+
         ' Vokabeln abgefragt.';
 MessageDlg(text,mtInformation,[mbOK],0);
end;

procedure TfTrainer.Benutzen1Click(Sender: TObject);
begin
 fLexikon.Show;
end;

procedure TfTrainer.showResults;
var text,s: String;
begin
 if (richtige+falsche) = 0 then Exit;

 Str((richtige/(richtige+falsche)*100):4:1,s);
 text := 'Fertig!'#10'Du hast '+IntToStr(richtige)+' Vokabeln von '+
         IntToStr(richtige+falsche) + ' Versuchen richtig beantwortet.'+
         #10'Das sind '+s+'%!';
 MessageDlg(text,mtInformation,[mbOK],0);
end;
procedure TfTrainer.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 //ergebnisse anzeigen
 showResults;

 if parentForm <> nil then parentForm^.Show;
end;

procedure TfTrainer.Betrachten1Click(Sender: TObject);
begin
 if Betrachten1.Checked then Betrachten1.Checked := false
                     else Betrachten1.Checked := true;
end;

procedure TfTrainer.FormShow(Sender: TObject);
begin
 if ParamCount > 0 then
   if FileExists(ParamStr(1)) then
     begin
       FileName := ParamStr(1);
       lesson1.LoadFromFile(FileName);
       Lektionenauswhlen1Click(Sender);
       Lektionenauswhlen1.Enabled := true;
       Benutzen1.Enabled := true;
       SetWindowPos(fChoose2.Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE+SWP_NOSIZE+SWP_SHOWWINDOW);
     end;
end;





end.
